/*recite-0.1*/
/*2003-09-18 zulkifli mohd salleh*/
#include	<iostream>
#include	<stdlib.h>
#include	<string.h>
#include	<errno.h>
#include	<stdarg.h>

int		ReadConfigString(FILE *fp, char *setting, char *value);
int		ReadConfigLine(FILE *fp, char *setting, char *value);
int		Read_Config_File(char *filename);
int		ReadPreviousFile(char *filename);
int		ReadSurahListFile(char *filename);
int		WriteStringPrevious(FILE *fp, char *setting, char *value);
int		WriteFilePrevious(char *filename);
int		WriteStringSurah(FILE *fp, char *setting, char *value);
int		WriteFileSurah(char *filename);
int		iLastLine, iPreviousLine;
char	*pFile, cDirectory[100];
char	cSurahName[256];

int main () {

	char	*home;
	char	tempfile[100];
    home = getenv("HOME");

	sprintf(tempfile, "%s/.wmsolat/wmsolatrc", home);
	pFile = tempfile;

	fprintf(stderr, "Going to read data from %s\n", pFile);

	if (!Read_Config_File(pFile))
	{
	    fprintf(stderr, "Cannot read file %s\n",pFile);
	}
	else
	{
	    fprintf(stderr, "Done readingfile %s\n",pFile);
	}

	/*extracting previous line from previous file*/
	sprintf(tempfile, "%s/.wmsolat/previous", home);
	pFile = tempfile;
	fprintf(stderr, "Going to read data from %s\n", pFile);

	/*extracting iPreviousLine*/
	if (!ReadPreviousFile(pFile))
	{
	    fprintf(stderr, "Cannot read file %s\n",pFile);
	}
	else
	{
	    fprintf(stderr, "Done reading file %s\n",pFile);
	}

	/*try to read file list here*/
	sprintf(tempfile, "%s/.wmsolat/surahlist", home);
	pFile = tempfile;
	fprintf(stderr, "Going to read data from %s\n", pFile);
	if (!ReadSurahListFile(pFile))
	{
	    fprintf(stderr, "Cannot read file %s\n",pFile);
	}
	else
	{
	    fprintf(stderr, "Successfully read file %s\n",pFile);
	}

	printf ("PreviousLine: %d\n", iPreviousLine);
	printf ("LastLine: %d\n", iLastLine);

	/*writing new iPreviousLine*/
	sprintf(tempfile, "%s/.wmsolat/previous", home);
	pFile = tempfile;

	if (!WriteFilePrevious(pFile))
	{
	    fprintf(stderr, "Cannot write file %s\n",pFile);
	}
	else
	{
	    fprintf(stderr, "Successfully wrote to file %s\n",pFile);
	}

	sprintf(tempfile, "%s/.wmsolat/surah", home);
	pFile = tempfile;

	if (!WriteFileSurah(pFile))
	{
	    fprintf(stderr, "Cannot write file %s\n",pFile);
	}
	else
	{
	    fprintf(stderr, "Successfully wrote to file %s\n",pFile);
	}

	return 0;
 }

/*********************************************************************************/
/*	end of main                                                                  */
/*********************************************************************************/

int ReadConfigString(FILE *fp, char *setting, char *value)
{
    char str[1024];
    char buf[1024];
    int i;
    int len;
    int slen;
    char *p=NULL;

    if (!fp) // nofile?
    {
        return 0;
    }

    snprintf(str,1024, "%s=", setting); // setting to str
    slen = strlen(str); //get length

    fseek(fp, 0, SEEK_SET); // set to beginning of file

    while ( !feof(fp) )  // not eof
    {

        if (!fgets(buf, 512, fp))   //cannot gets 512
	  break;						// read one line

        len = strlen(buf);

        /* strip linefeed */
        for (i=0; i!=len; i++)
	  if (buf[i] == '\n')
	    buf[i] = 0;

        /* printf("Scanning '%s'...\n", buf); */
        if ( strncmp(buf, str, strlen(str)) == 0)
        {
            /* found our setting */

	  for(i=0; i!=slen; i++)
	    if ( buf[i] == '=' )
	      {
		p=buf+i+1;
		strcpy(value, p); // returning value as character
		return 1;
	      }
        }
    }
    return 0;
}

/*****************************************************************************/
/* Read surah name from filelist                                             */
/*****************************************************************************/
int ReadSurahListFile( char *filename )
{
    FILE *fp;
    char temp[100];

    fp = fopen(filename, "r"); /*open read only*/
    if (fp)
    {
/*		printf("File is: %s\n", filename);          */
		sprintf(temp, "%d", iPreviousLine+1);
/*		printf("iLastLine now: %d\n", iLastLine);   */
		ReadConfigLine(fp, temp, cSurahName);
		printf ("Surah name is %s\n", cSurahName);

	//	fclose(fp);
        return 1;
    }
    else
    {
		printf("Failed to open file %s\n", filename);
		return 0;
    }
}


int ReadPreviousFile( char *filename )
{
    FILE *fp;
    char temp[100];

    fp = fopen(filename, "r"); /*open read only*/
    if (fp)
    {

		/*reading previous*/
		ReadConfigString(fp, "PreviousLine", temp);
		iPreviousLine = atoi(temp);
		fclose(fp);
        return 1;
    }
    else
    {
		printf("Failed to open file %s\n", filename);
		return 0;
    }
}


/*****************************************************************************\
|* Read_Config_File                                                          *|
\*****************************************************************************/
int Read_Config_File( char *filename )
{
    FILE *fp;
    char temp[100];

    fp = fopen(filename, "r"); /*open read only*/
    if (fp)
    {

		/*reading wmsolatrc*/
		ReadConfigString(fp, "SurahDirectory", cDirectory);
		ReadConfigString(fp, "LastLine", temp);
		iLastLine = atoi(temp);
		fclose(fp);
        return 1;
    }
    else
    {
		printf("Failed to open file %s\n", filename);
		return 0;
    }
}

/*****************************************************************************\
|* Write to File  previous                                                   *|
\*****************************************************************************/
int WriteFilePrevious( char *filename )
{
    FILE *fp;
    char temp[100], buf[100];

    fp = fopen(filename, "w"); /*open write only*/
    if (fp)
    {
		printf("Writing to file %s\n", filename);
		sprintf(buf, "%d", iPreviousLine);
		WriteStringPrevious(fp, "PreviousLine", buf);
		fclose(fp);
        return 1;
    }
    else
    {
		printf("Failed to open file %s\n", filename);
		return 0;
    }
}

int WriteStringPrevious(FILE *fp, char *setting, char *value)
{
    char str[1024];
    char buf[1024];
    int i;
    int len;
    int slen;
    char *p=NULL;

    if (!fp) // nofile?
    {
        return 0;
    }

	snprintf(buf, 1024, "%s=%s", setting, value);
	slen = strlen(buf); //get length
	printf("Value to write %s\n", buf);
	fwrite (buf, 1, slen, fp);

    return 0;
}

int WriteFileSurah( char *filename )
{
    FILE *fp;
    char temp[100], buf[100];

    fp = fopen(filename, "w"); /*open write only*/
    if (fp)
    {
		printf("Writing to file %s\n", filename);

		WriteStringSurah(fp, cDirectory, cSurahName);
		fclose(fp);
        return 1;
    }
    else
    {
		printf("Failed to open file %s\n", filename);
		return 0;
    }
}

int WriteStringSurah(FILE *fp, char *setting, char *value)
{
    char str[1024];
    char buf[1024];
    int i;
    int len;
    int slen;
    char *p=NULL;

    if (!fp) // nofile?
    {
        return 0;
    }

	snprintf(buf, 1024, "%s%s", setting, value);
	slen = strlen(buf); //get length
	printf("Value to write %s\n", buf);
	fwrite (buf, 1, slen, fp);

    return 0;
}

int ReadConfigLine(FILE *fp, char *setting, char *value)
{
	/*setting is line number, can discard*/
	/*we are using the global iPreviousLine*/
    char str[1024];
    char buf[1024];
    int i;
    int len;
    int slen;
    char *p=NULL;

	if (!fp) // nofile?
    {
        return 0;
    }

	fseek(fp, 0, SEEK_SET); // set to beginning of file

	/*we are traversing down to the required line*/
	for (i=0; i < (iPreviousLine+1); i++)
	{
		if (!fgets(buf, 512, fp))   //cannot gets 512
		break;						// read one line
	}
	fclose(fp);
	
/*	fprintf(stderr,"buf is %s\n", buf);                    */
/*	fprintf(stderr,"counter i is %d.\n", i);               */
/*	fprintf(stderr,"iLastLine is: %d.\n", iLastLine);      */
	
	if (feof(fp) || i > iLastLine)
	{
		fprintf(stderr,"Starting reading %s again at beginning\n", pFile);
		iPreviousLine = 2;
		fprintf(stderr,"File is closed, going to reopen\n");

		fp = fopen(pFile, "r"); /*open read only*/
		if (fp)
		{
			for (i=0; i < (iPreviousLine+1); i++)
			{
				if (!fgets(buf, 512, fp))   //cannot gets 512
				break;						// read one line
			}
			fclose(fp);
		}
	}
	iPreviousLine++;
	p = buf;
	strcpy(value, p);
	return 1;
}
