/*
 * wmmuezzin.c
 * par lilian
 *
 * 1999/paris/La nuit
 */

/*
 * Les includes
 */

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <string.h>
#include <unistd.h>
#include <X11/xpm.h>
#include "../wmgeneral/wmgeneral.h"
#include "../wmgeneral/misc.h"
#include "wmmuezzin-master.xpm"
#include "wmmuezzin-mask.xbm"
#include <sys/wait.h>
#include <sys/types.h>
/*
 * Les Definitions
 */

int	sound_bt_status=1;
int	button_state=-1;
int	isw;
XEvent  Event;
int	next_prayer;
int	list_praying_hour[6];
int	list_praying_minute[6];
int	mark_prayer[6];
short	qiblah_d;
short	qiblah_m;
int	ok_for_today=0;
int	page=-1;
char	tmp[50];

/* to read from config file, codes lifted from wmtz zulkifli 07-2003*/
char	scriptFileAzan[253];
char	scriptFileOpen[253];
char	scriptFileRemind[253];
int	after_midnite=0;
int	reminded=0;
int	reminder_minutes;

/*
 * Les Fonctions
 */

void ButtonUp(int);
void ButtonDown(int);
void DrawSun(int);
void DrawName(int);
void DrawTime(int);
void DrawQiblah(void);
void InitVarCompareTime(void);
void UpdateContext(void);
void CompareTime(void);
/*void ExecCmd(); */
/*void ExecRemind(); */

extern void GetCallingPrayer();

/*
 * Yalla
 */

int main(int argc,char *argv[]) {

	openXwindow(argc, argv, wmmuezzin_master_xpm, wmmuezzin_mask_bits,
				wmmuezzin_mask_width, wmmuezzin_mask_height);

	AddMouseRegion(0,5,49,19,60);
	AddMouseRegion(1,5,5,54,18);

	/*we need more info on the terminal to see what is happening zul 07-2003*/

	fprintf(stderr, "\nwmsolat-0.4.1 running ........... :)\n");
	GetCallingPrayer();
	InitVarCompareTime();
	fprintf(stderr, "\nPlease wait, initializing.........\n");
	
	if (sound_bt_status) waitpid(execCommand(scriptFileOpen), NULL,0);
	
	if (next_prayer==9)
		DrawTime(5);
	else
		DrawTime(next_prayer);
	DrawQiblah();

	fprintf(stderr, "hit enter and type 'exit' to quit this terminal.\n");
							
	while (1)
	{
		CompareTime();
		while (XPending(display))
		{
			XNextEvent(display, &Event);
			switch (Event.type) 
			{
				case Expose:
					/* On se fait beau */
					RedrawWindow();
				break;
				case DestroyNotify:
					/* Ciao */
					XCloseDisplay(display);
					exit(0);
				break;
				case ButtonPress:
					/* Bouton enfonce */
					isw = CheckMouseRegion(Event.xbutton.x, Event.xbutton.y);
					switch (isw)
					{
						case 0:			/* Activation/deactivation son */
							if (sound_bt_status == 1) {
								sound_bt_status=0;
								ButtonDown(0);
							} else {
								sound_bt_status=1;
								ButtonUp(0);
							}
						break;
						case 1:			/* Liste des horaires */
							page++;
							if (page >= 6) page=0;
							DrawTime(page);
						break;
					}
					button_state = isw;
				break;
			}
		}
		usleep (10000);	/* prevent 100% CPU, other dockapps using this value zul 07-2003 */
	}
}

/*
 * Initialisation
 */

void InitVarCompareTime() {
time_t	myt;
struct  tm local_time;
int	i;

	time(&myt);
	local_time=*localtime(&myt);

	if ((local_time.tm_hour == 0) && (next_prayer == 9) && (ok_for_today == 1)) {
		GetCallingPrayer();
		next_prayer=0;
		ok_for_today=0;
		page=0;
	}

	if (!ok_for_today) {
		for (i=0; i<6; i++) {
			mark_prayer[i]=0;
			if  (local_time.tm_hour > list_praying_hour[i]) mark_prayer[i]=1;
			if ((local_time.tm_hour == list_praying_hour[i]) &&
			    (local_time.tm_min  > list_praying_minute[i])) mark_prayer[i]=1;
		}

		i=0;
		next_prayer=-1;
		while (next_prayer==-1) {
			if (i > 6) {
				next_prayer=9; /* Termine pour aujourd'hui, on remballe les tapis */
				ok_for_today=1; /* on va se coucher, demain il fera jour */
			}
			if (mark_prayer[i]==0) next_prayer=i;
			i++;
		}
		if (page == -1) page=next_prayer;
	}
}

/*
 * Mise a jour du contexte
 */

void UpdateContext() {
int	i=0;

	if (!ok_for_today) {
		next_prayer=-1;
		while (next_prayer==-1) {
			if (i > 6) {
				next_prayer=9; /* Termine pour aujourd'hui, on remballe les tapis */
				ok_for_today=1; /* on va se coucher, demain il fera jour */
			}
			if (mark_prayer[i]==0) next_prayer=i;
			i++;
		}
		if (page == -1) page=next_prayer;
	} else {
		InitVarCompareTime();
	}
}


/*
 * Comparaison de l'heure locale avec les heures de priere
 */

void CompareTime() {
time_t	myt;
struct  tm local_time;
int	i, flag=0;
int	timeinminutes, before_prayer_hour, before_prayer_min;

	time(&myt);
	local_time=*localtime(&myt);

	/*at midnite, reinitialize once for new day zul 07-2003 */
	if ((local_time.tm_hour == 0) && (local_time.tm_min == 0) && (after_midnite == 0)) {

		fprintf(stderr, "\nIt is now midnight, need to update for next day.\n");
		after_midnite = 1; /*call here once only*/
		next_prayer=0;
		ok_for_today=0;
		page=0;
		GetCallingPrayer();
		InitVarCompareTime();

		if (next_prayer==9)
			DrawTime(5);
		else
			DrawTime(next_prayer);

		DrawQiblah();
	}

	/*checking for prayers which has not been marked*/
	for (i=0; i<6; i++) {

		if (((local_time.tm_hour == list_praying_hour[i]) &&
		     (local_time.tm_min  == list_praying_minute[i]) &&
		     (mark_prayer[i] == 0))) {
			mark_prayer[i]=1;
			
/*			ExecCmd(); */
			
			if (sound_bt_status) waitpid(execCommand(scriptFileAzan), NULL,0);

			flag=1;
			fprintf(stderr, "\nmark_prayer[%d]\n",i);
			/*set flag for reinitializing at midnite     */
			/*initially = 1, every prayer time reset to 0*/
			/*lazy me, version 0.2 zul 07-2003           */
			after_midnite=0;
			reminded=0;
		}
		/*to recite something as an advance reminder       */
		/*so that we will have time to go to surau whatever*/
		/*version 0.3 zul 07-2003                          */
		if (mark_prayer[i] == 0){
			timeinminutes = ( list_praying_hour[i] * 60 + list_praying_minute[i] ) - reminder_minutes;
			before_prayer_min = timeinminutes % 60;
			before_prayer_hour = timeinminutes / 60;

			if ((local_time.tm_hour == before_prayer_hour) &&
				(local_time.tm_min  == before_prayer_min) &&
				(reminded == 0)){
				reminded=1;
				fprintf(stderr, "\nYou are reminded :[%d]\n",reminded);
/*				ExecRemind();*/
				if (sound_bt_status) waitpid(execCommand(scriptFileRemind), NULL,0);
		
			}
		}
	}
	UpdateContext();
	if (flag) DrawTime(next_prayer);
}

void DrawQiblah() {
int	c, i, k;
char	buf[1024];

	sprintf(buf, "%03i", qiblah_d);
	k = 13;
	for (i=0; buf[i]; i++) {
        	c = buf[i];
		c -= '0';
		copyXPMArea(c * 6, 65, 6, 7, k, 34);
		k += 6;
	}

	sprintf(buf, "%02i", qiblah_m);
	k = 33;
	for (i=0; buf[i]; i++) {
        	c = buf[i];
		c -= '0';
		copyXPMArea(c * 6, 65, 6, 7, k, 34);
		k += 6;
	}

	RedrawWindow();
}

/*
 * Affichage d'un horaire
 */

void DrawTime(int next_time) {
int	c, i, k;
char	buf[1024];

	sprintf(buf, "%02i", list_praying_hour[next_time]);
	k = 18;
	for (i=0; buf[i]; i++) {
        	c = buf[i];
		c -= '0';
		copyXPMArea(c * 6, 65, 6, 7, k, 14);
		k += 6;
	}

	copyXPMArea(61, 64, 1, 9, 31, 14);

	sprintf(buf, "%02i", list_praying_minute[next_time]);
	k = 32;
	for (i=0; buf[i]; i++) {
        	c = buf[i];
		c -= '0';
		copyXPMArea(c * 6, 65, 6, 7, k, 14);
		k += 6;
	}

	if (next_time == next_prayer)
		copyXPMArea(48, 100, 3, 3, 6, 19);
	else
		copyXPMArea(52, 100, 3, 3, 6, 19);

	if (mark_prayer[next_time] ==1) copyXPMArea(56, 100, 3, 3, 6, 19);
	if (next_prayer == 9) copyXPMArea(56, 100, 3, 3, 6, 19);

	RedrawWindow();
	DrawName(next_time);
	DrawSun(next_time);
}

/*
 * C'est la plage horaire d'une priere en arabe
 */

void DrawName( int time_num ) {

	copyXPMArea(0, 74+(9*time_num), 37, 9, 13, 5);
	RedrawWindowXYWH(13, 5, 37, 9);
	RedrawWindow();
}

/*
 * Et la lumiere fut !
 */

void DrawSun(int sun_position) {

	copyXPMArea(44, 105, 36, 11, 23, 48);
	RedrawWindowXYWH(23, 48, 36, 11);

	switch (sun_position)
	{
		case 0:
			copyXPMArea(44, 100, 3, 3, 24, 56);
			RedrawWindowXYWH(24, 56, 3, 3);
		break;
		case 1:
			copyXPMArea(44, 100, 3, 3, 30, 52);
			RedrawWindowXYWH(30, 52, 3, 3);
		break;
		case 2:
			copyXPMArea(44, 100, 3, 3, 36, 49);
			RedrawWindowXYWH(36, 49, 3, 3);
		break;
		case 3:
			copyXPMArea(44, 100, 3, 3, 42, 51);
			RedrawWindowXYWH(42, 51, 3, 3);
		break;
		case 4:
			copyXPMArea(44, 100, 3, 3, 48, 54);
			RedrawWindowXYWH(48, 54, 3, 3);
		break;
		case 5:
			copyXPMArea(44, 100, 3, 3, 54, 56);
			RedrawWindowXYWH(54, 56, 3, 3);
		break;
	}

	RedrawWindow();
}

/*
 * Un on enfonce le bouton
 */

void ButtonDown(int button) {

	switch (button)
	{
		case 0:
			copyXPMArea(44, 86 , 14, 11 ,5, 48);
			RedrawWindowXYWH(5, 48, 14, 11);
		break;
		case 1:
			copyXPMArea(55, 100, 12, 11, 23, 48);
			RedrawWindowXYWH(23, 48, 12, 11);
		break;
	}
}

/*
 * Et deux on relache le bouton
 */

void ButtonUp(int button) {

	switch (button)
	{
		case 0:
			copyXPMArea(44, 74 , 14, 11 ,5, 48);
			RedrawWindowXYWH(5, 48, 14, 11);
		break;
		case 1:
			copyXPMArea(55, 88, 12, 11, 23, 48);
			RedrawWindowXYWH(23, 48, 12, 11);
		break;
	}
}

/*
 * Execution d'une commande externe
 */

/*
void ExecCmd() {
	if (sound_bt_status) waitpid(execCommand(scriptFileAzan), NULL,0); }
*/

/*
void ExecRemind() {
	if (sound_bt_status) waitpid(execCommand(scriptFileRemind), NULL,0); }

*/
